package handlers

import (
	"fmt"
	"net/http"

	"git.agecem.com/agecem/bottin/v4/data"
	"github.com/labstack/echo/v4"
)

type GetHealthResponse struct {
	Message string `json:"message"`
}

func GetHealth(c echo.Context) error {
	response := GetHealthResponse{
		Message: "Bottin API v4 is ready",
	}

	dataClient, err := data.NewDataClientFromViper()
	if err != nil {
		response.Message = fmt.Sprintf("Error during data.NewDataClientFromViper(): %s", err)

		return c.JSON(http.StatusInternalServerError, response)
	}
	defer dataClient.DB.Close()

	if err = dataClient.DB.Ping(); err != nil {
		response.Message = fmt.Sprintf("Error during dataClient.DB.Ping(): %s", err)

		return c.JSON(http.StatusInternalServerError, response)
	}

	return c.JSON(http.StatusOK, response)
}
